#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "reduce_pipe_connection4xi.py">
#<abstract4xi abstract = "providing function reduce_pipe_connection4xi"/>
#<refer4xi reference = "reduction.py"/>
#<state4xi status = "[ACK4tagging] [ACK4OS2ALL] [NACK4moduletesting] [NACK4systemtesting] [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'reduce_pipe_connection4xi' ]
#" 
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
    from _winapi import WAIT_OBJECT_0, WAIT_TIMEOUT, INFINITE
except ImportError:
    if sys.platform == 'win32':
        raise
    _winapi = None

                
 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.reduction import reduce_pipe_connection
except:
    print("reduce_pipe_connection4xi.py: *** failed in from multiprocessing.reduction import reduce_pipe_connection ***")

#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from constant_system4xi import get_windows_system4xi
from forkingpickler4xi import ForkingPickler4Xi
from print4xi import print4xi
from rebuild_pipe_connection4xi import rebuild_pipe_connection4xi
from reduce_handle4xi import reduce_handle4xi
from time4xi import time4xi
#"
#/>
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "reduce_pipe_connection4xi" usage = "
#     directing to use multiprocessing package pipes 
#"> 
#<state4xi status = "[ACK4tagging] [ACK4OS2ALL] [NACK4moduletesting] [NACK4systemtesting] [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------
def reduce_pipe_connection4xi(conn):
    class2print = "reduce_pipe_connection4xi"
    method2print = "reduce_pipe_connection4xi"

    if sys.platform == 'win32':
        
        # -----------------------------------------------------------------------------------------    
        # (Step 1/3) - Windows
        # -----------------------------------------------------------------------------------------     
        message2print = "{(Step 1/3a) started" + "; reduce-pipe-connection4xi-started: " + str(reduce_pipe_connection4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
            
        message2print = "{(Step 1/3b) passed" + "; conn-passed-to-reduce-pipe-connection4xi: " + str(conn) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                      

        # -----------------------------------------------------------------------------------------    
        # (Step 2/3) - Windows
        # -----------------------------------------------------------------------------------------     
        access2xi = ((_winapi.FILE_GENERIC_READ if conn.readable else 0) |
                  (_winapi.FILE_GENERIC_WRITE if conn.writable else 0))
    
        message2print = "{(Step 2/3a) set" + "; access2xi-reduce-set-by-reduce-pipe-connection4xi to: " + str(access2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
         
        message2print = "{(Step 2/3b) passing" + "; conn-fileno-passing-to-DupHandle4Xi-by-reduce-pipe-connection4xi: " + str(conn.fileno()) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        message2print = "{(Step 2/3c) passing" + "; access2xi-passing-to-DupHandle4Xi-by-reduce-pipe-connection4xi: " + str(access2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #                
        
        dh2xi = DupHandle4Xi(conn.fileno(), access2xi)
         
        message2print = "{(Step 2/3d) set" + "; dh2xi-reduce-set-by-reduce-pipe-connection4xi to: " + str(dh2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
           
        # -----------------------------------------------------------------------------------------    
        # (Step 3/3) - Windows
        # -----------------------------------------------------------------------------------------     
          
    
        message2print = "{(Step 3/3a) passing" + "; dh2xi-passing-to-rebuild-pipe-connection4xi-by-reduce-pipe-connection4xi: " + str(dh2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
        message2print = "{(Step 3/3b) passing" + "; conn-readable-passing-to-rebuild-pipe-connection4xi-by-reduce-pipe-connection4xi: " + str(conn.readable) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
                            
        message2print = "{(Step 3/3c) passing" + "; conn-writable-passing-to-rebuild-pipe-connection4xi-by-reduce-pipe-connection4xi: " + str(conn.writable) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
            
            
                    
        message2print = "{(Step 3/3d) returning" + "; rebuild-pipe-connection4xi-function-returning-by-reduce-pipe-connection4xi: " + str(rebuild_pipe_connection4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                    
        return rebuild_pipe_connection4xi, (dh2xi, conn.readable, conn.writable)
    
    else: 
        # -----------------------------------------------------------------------------------------    
        # (Step 1/3) - non-Windows should not be called! 
        # -----------------------------------------------------------------------------------------     
          
        message2print = "{(Step 1/3a) started" + "; reduce_pipe_connection4xi-started: " + str(reduce_pipe_connection4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        message2print = "{(Step 1/3b) warned" + "; usage-warned-by-reduce_pipe_connection4xi: " + str("** reduce_pipe_connection4xi to be called only in Windows systems  **")  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
            
        message2print = "{(Step 1/3c) returning" + "; reduce_pipe_connection4xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        
        return reduce_pipe_connection(conn)
           
    #</function4xi>

    
    # -------------------------------------------------------------------------------------------------
    # Register in module level                            
    # ------------------------------------------------------------------------------------------------- 
    #<register4xi registration = "
    # [Rel 7.21] omitted ForkingPickler4Xi.register(_multiprocessing.PipeConnection, reduce_pipe_connection4xi)
    #"
    #>
    
    
    
#</program4xi>



# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of reduce_pipe_connection4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
